

$current_module = "no";

print "\n\npublic import iotype;\n\n";
print "\n\nextern(C):\n\n";


sub codefix {
  shift;

  # mibae
  s/^\s+//;
  s/\r//g;
  s/\n//g;
  s/\b//g;
  s/\s+$//;
  s/\s{2,}/ /g;

  # parse linkage
  s/([A-Z]+)_API\s+//;
  s/IOINLINE\s+//g;
  
  # D style type
  s/\s+\*(?!\/)/\* /g; # void *p -> void* p
  s/\(void\)/()/g;
  s/long/int/g;
  s/unsigned\s+char/ubyte/g;
  s/unsigned\s+int/uint/g;
  s/unsigned/uint/g;
  s/struct\s+//g;
  s/const\s+(.+?)\b/const($1)/g;

  # remove '*' from function type
  s/(IoUserFunction)\*/$1/g;
  s/(Io([a-zA-Z0-9_]+)Func)\*/$1/g;
  s/(Io([a-zA-Z0-9_]+)Callback)\*/$1/g;
  s/(CHash([a-zA-Z0-9_]+)Func)\*/$1/g;
  s/(List([a-zA-Z0-9_]+)Callback)\*/$1/g;
  s/(Stack([a-zA-Z0-9_]+)Callback)\*/$1/g;
  s/(UArray([a-zA-Z0-9_]+)Callback)\*/$1/g;
  s/(Coro([a-zA-Z0-9_]+)Callback)\*/$1/g;
  s/(Collector([a-zA-Z0-9_]+)Callback)\*/$1/g;

  # keyword collision avoidance
  s/ref/ref_/g;

  # fix misc
  $_ = "// ". $_ if (/PID_TYPE/);

  # for inline function
  s/\s*\{\s*$//;
  $_ .= ";" unless (/;$/);

  $_;
}


open(IN, "iovmapi.txt");
for (<IN>) {
  $_ =~ /^(.+?)\((\d+)\)\:(.*?)$/;
  $path = $1;
  $line = $2;
  $code = $3;

  $path =~ /^.*\\(.+?)\.h$/;
  $module = $1;
  if ($module ne $current_module) {
    print "\n\n";
    print "/", '*' x 76, "\n";
    print "     $module\n";
    print " ", '*' x 76, "/\n";
    $current_module = $module;
  }

  # code conversion
  $_ = $code;
  if (/^\s*\#/) {
    # for interpreter
    $_ = "";
  }
  elsif (/IO_METHOD/) {
    chomp;
    s/IOVM_API //;
    #s/IO_METHOD\((.*?)\, (.*?)\)/IoObject* ${1}_${2}(${1}* self, IoObject* locals, IoMessage* m)/;
    s/IO_METHOD\((.*?)\, (.*?)\)/IoObject* ${1}_${2}(${1}* self, IoObject* locals, IoMessage* m)/;
    &codefix($_);
  }
  elsif (/\,\s*$/ or /\(\s*$/) {
    #print "($path $line read)\n";
    open(IN2, "$path");
    <IN2> for (1 .. $line-1);
    $buf = "";
    for (<IN2>) {
      chomp;
      $buf .= $_;
      last if (/\;/ or /\{/);
    }
    close(IN2);
    $_ = $buf;
    &codefix($_);
  }
  else {
    $_ = $code;
    &codefix($_);
  }
  print "$_\n" if ($_);
}
close(IN);



