module io4d.iovmapi;

public import io4d.iotype;



extern(C):



/****************************************************************************
     BStream
 ****************************************************************************/
BStream* BStream_new();
BStream* BStream_clone(BStream* self);
void BStream_free(BStream* self);
char* BStream_errorString(BStream* self);
void BStream_setUArray_(BStream* self, UArray* ba);
void BStream_setData_length_(BStream* self, ubyte* data, size_t length);
UArray* BStream_byteArray(BStream* self);
void BStream_empty(BStream* self);
int BStream_isEmpty(BStream* self);
void BStream_writeByte_(BStream* self, ubyte v);
void BStream_writeUint8_(BStream* self, uint8_t v);
void BStream_writeUint32_(BStream* self, uint32_t v);
void BStream_writeInt32_(BStream* self, int32_t v);
void BStream_writeInt64_(BStream* self, int64_t v);
void BStream_writeDouble_(BStream* self, double v);
void BStream_writeData_length_(BStream* self, const(ubyte)* data, size_t length);
void BStream_writeCString_(BStream* self, const(char)* s);
void BStream_writeUArray_(BStream* self, UArray* ba);
ubyte BStream_readByte(BStream* self);
uint8_t BStream_readUint8(BStream* self);
uint32_t BStream_readUint32(BStream* self);
int32_t BStream_readInt32(BStream* self);
int64_t BStream_readInt64(BStream* self);
double BStream_readDouble(BStream* self);
uint8_t* BStream_readDataOfLength_(BStream* self, size_t length);
void BStream_readUArray_(BStream* self, UArray* b);
UArray* BStream_readUArray(BStream* self);
const(char)* BStream_readCString(BStream* self);
void BStream_writeTaggedUint8_(BStream* self, uint8_t v);
void BStream_writeTaggedUint32_(BStream* self, uint32_t v);
void BStream_writeTaggedInt32_(BStream* self, int32_t v);
void BStream_writeTaggedInt64_(BStream* self, int64_t v);
void BStream_writeTaggedDouble_(BStream* self, double v);
void BStream_writeTaggedData_length_(BStream* self, const(ubyte)* data, size_t length);
void BStream_writeTaggedCString_(BStream* self, const(char)* s);
void BStream_writeTaggedUArray_(BStream* self, UArray* ba);
uint8_t BStream_readTaggedUint8(BStream* self);
uint32_t BStream_readTaggedUint32(BStream* self);
int32_t BStream_readTaggedInt32(BStream* self);
int64_t BStream_readTaggedInt64(BStream* self);
double BStream_readTaggedDouble(BStream* self);
void BStream_readTaggedUArray_(BStream* self, UArray* b);
UArray* BStream_readTaggedUArray(BStream* self);
const(char)* BStream_readTaggedCString(BStream* self);
void BStream_show(BStream* self);


/****************************************************************************
     CHash
 ****************************************************************************/
CHash* CHash_new();
void CHash_copy_(CHash* self, const(CHash)* other);
CHash* CHash_clone(CHash* self);
void CHash_free(CHash* self);
void CHash_setHash1Func_(CHash* self, CHashHashFunc f);
void CHash_setHash2Func_(CHash* self, CHashHashFunc f);
void CHash_setEqualFunc_(CHash* self, CHashEqualFunc f);
void CHash_removeKey_(CHash* self, void* k);
void CHash_clear(CHash* self);
size_t CHash_size(CHash* self); // actually the keyCount;
size_t CHash_memorySize(CHash* self);
void CHash_compact(CHash* self);
void CHash_setSize_(CHash* self, size_t size);
int CHash_insert_(CHash* self, CHashRecord* x);
void CHash_grow(CHash* self);
void CHash_shrink(CHash* self);
void CHash_show(CHash* self);
void CHash_updateMask(CHash* self);
float CHash_density(CHash* self);


/****************************************************************************
     CHash_inline
 ****************************************************************************/
CHashRecord* CHash_record1_(CHash* self, void* k);
CHashRecord* CHash_record2_(CHash* self, void* k);
void* CHash_at_(CHash* self, void* k);
size_t CHash_count(CHash* self);
int CHashKey_hasKey_(CHash* self, void* key);
int CHash_at_put_(CHash* self, void* k, void* v);
void CHash_shrinkIfNeeded(CHash* self);
void CHashRecord_swapWith_(CHashRecord* self, CHashRecord* other);
void CHash_clean(CHash* self);


/****************************************************************************
     Common
 ****************************************************************************/
//#define BASEKIT_API;
size_t io_memsize(void* ptr);
void* io_real_malloc(size_t size, char* file, int line);
void* io_real_calloc(size_t count, size_t size, char* file, int line);
void* io_real_realloc(void* ptr, size_t newSize, char* file, int line);
void io_free(void* ptr);
void io_show_mem(char* s);
size_t io_maxAllocatedBytes();
void io_resetMaxAllocatedBytes();
size_t io_frees();
size_t io_allocs();
size_t io_allocatedBytes();
void io_showUnfreed();
void* cpalloc(const(void)* p, size_t size);
void* io_freerealloc(void* p, size_t size);
uint32_t io_uint32InBigEndian(uint32_t i);


/****************************************************************************
     Common_inline
 ****************************************************************************/


/****************************************************************************
     Date
 ****************************************************************************/
double Date_SecondsFrom1970ToNow();
Date* Date_new();
void Date_copy_(Date* self, const(Date)* other);
void Date_free(Date* self);
int Date_compare(const(Date)* self, const(Date)* other);
void Date_now(Date* self);
void Date_setToLocalTimeZone(Date* self);
double Date_Clock();
void Date_fromLocalTime_(Date* self, tm* t);
void Date_fromTime_(Date* self, time_t t);
time_t Date_asTime(const(Date)* self);
void Date_setToLocalTimeZone(Date* self);
timezone Date_timeZone(const(Date)* self);
void Date_setTimeZone_(Date* self, timezone tz);
void Date_convertToTimeZone_(Date* self, timezone tz);
void Date_setYear_(Date* self, int y);
int Date_year(const(Date)* self);
void Date_setMonth_(Date* self, int m);
int Date_month(const(Date)* self);
void Date_setDay_(Date* self, int d);
int Date_day(const(Date)* self);
void Date_setHour_(Date* self, int h);
int Date_hour(const(Date)* self);
void Date_setMinute_(Date* self, int m);
int Date_minute(const(Date)* self);
void Date_setSecond_(Date* self, double s);
double Date_second(const(Date)* self);
UArray* Date_asSerialization(Date* self);
Date* Date_fromSerialization(Date* self, UArray* serialization);
ubyte Date_isDaylightSavingsTime(const(Date)* self);
int Date_isLeapYear(const(Date)* self);
double Date_asSeconds(const(Date)* self);
void Date_fromSeconds_(Date* self, double s);
void Date_addSeconds_(Date* self, double s);
double Date_secondsSince_(const(Date)* self, const(Date)* other);
void Date_fromString_format_(Date* self, const(char)* s, const(char)* format);
Duration* Date_newDurationBySubtractingDate_(const(Date)* self, const(Date)* other);
void Date_addDuration_(Date* self, const(Duration)* d);
void Date_subtractDuration_(Date* self, const(Duration)* d);
double Date_secondsSinceNow(const(Date)* self);
UArray* Date_asString(const(Date)* self, const(char)* format);


/****************************************************************************
     Duration
 ****************************************************************************/
Duration* Duration_new();
Duration* Duration_newWithSeconds_(double s);
Duration* Duration_clone(const(Duration)* self);
void Duration_copy_(Duration* self, const(Duration)* other);
void Duration_free(Duration* self);
int Duration_compare(const(Duration)* self, const(Duration)* other);
int Duration_years(const(Duration)* self);
void Duration_setYears_(Duration* self, double y);
int Duration_days(const(Duration)* self);
void Duration_setDays_(Duration* self, double d);
int Duration_hours(const(Duration)* self);
void Duration_setHours_(Duration* self, double m);
int Duration_minutes(const(Duration)* self);
void Duration_setMinutes_(Duration* self, double m);
double Duration_seconds(const(Duration)* self);
void Duration_setSeconds_(Duration* self, double s);
double Duration_asSeconds(const(Duration)* self);
void Duration_fromSeconds_(Duration* self, double s);
UArray* Duration_asUArrayWithFormat_(const(Duration)* self, const(char)* format);
void Duration_print(const(Duration)* self);
void Duration_add_(Duration* self, const(Duration)* other);
void Duration_subtract_(Duration* self, const(Duration)* other);


/****************************************************************************
     DynLib
 ****************************************************************************/
DynLib* DynLib_new();
void DynLib_free(DynLib* self);
void DynLib_setPath_(DynLib* self, const(char)* path);
char* DynLib_path(DynLib* self);
void DynLib_setInitFuncName_(DynLib* self, const(char)* name);
char* DynLib_initFuncName(DynLib* self);
void DynLib_setInitArg_(DynLib* self, void* arg);
void DynLib_setFreeFuncName_(DynLib* self, const(char)* name);
char* DynLib_freeFuncName(DynLib* self);
void DynLib_setFreeArg_(DynLib* self, void* arg);
void DynLib_setError_(DynLib* self, const(char)* path);
char* DynLib_error(DynLib* self);
void DynLib_open(DynLib* self);
ubyte DynLib_isOpen(DynLib* self);
void DynLib_close(DynLib* self);
void* DynLib_pointerForSymbolName_(DynLib* self, const(char)* symbolName);


/****************************************************************************
     List
 ****************************************************************************/
List* List_new();
List* List_clone(const(List)* self);
List* List_cloneSlice(const(List)* self, int startIndex, int endIndex, int step);
void List_free(List* self);
void List_removeAll(List* self);
void List_copy_(List* self, const(List)* otherList);
int List_equals_(const(List)* self, const(List)* otherList);
size_t List_memorySize(const(List)* self);
UArray List_asStackAllocatedUArray(List* self);
void List_preallocateToSize_(List* self, size_t index);
void List_setSize_(List* self, size_t index);
void List_compact(List* self);
void List_print(const(List)* self);
void List_sliceInPlace(List* self, int startIndex, int endIndex, int slice);
void List_do_(List* self, ListDoCallback callback);
void List_do_with_(List* self, ListDoWithCallback callback, void* arg);
List* List_map_(List* self, ListCollectCallback callback);
void List_mapInPlace_(List* self, ListCollectCallback callback);
void* List_detect_(List* self, ListDetectCallback callback);
List* List_select_(List* self, ListSelectCallback callback);
void* List_anyOne(const(List)* self);
void List_shuffle(List* self);
void* List_removeLast(List* self);


/****************************************************************************
     List_inline
 ****************************************************************************/
size_t List_size(const(List)* self);
void List_ifNeededSizeTo_(List* self, size_t newSize);
void* List_rawAt_(List* self, size_t index);
void* List_at_(const(List)* self, ssize_t index);
size_t List_indexOf_(List* self, void* item);
int List_contains_(List* self, void* item);
void* List_append_(List* self, void* item);
void List_appendSeq_(List* self, const(List)* otherList);
void List_compactIfNeeded(List* self);
void List_removeIndex_(List* self, size_t index);
void List_removeIndex_toIndex_(List* self, size_t index1, size_t index2);
void List_remove_(List* self, void* item);
int List_removeFirst_(List* self, void* item);
void List_removeLast_(List* self, void* item);
void List_removeItems_(List* self, List* other);
void List_at_insert_(List* self, size_t index, void* item);
void List_at_put_(List* self, size_t index, void* item);
void List_swap_with_(List* self, int index1, int index2);
void List_reverseInPlace(List* self);
void List_push_(List* self, void* item);
void* List_pop(List* self);
void* List_top(const(List)* self);
int List_removeTrueFor_(List* self, ListCollectCallback callback);
void List_qsort(List* self, ListSortCallback callback);
void List_qsort_r(List* self, void* context, ListSortRCallback callback);
void* List_bsearch(List* self, const(void)* key, ListSortCallback callback);
void* List_first(const(List)* self);
void* List_last(List* self);


/****************************************************************************
     MainArgs
 ****************************************************************************/
MainArgs* MainArgs_new();
void MainArgs_free(MainArgs* self);
void MainArgs_argc_argv_(MainArgs* self, int argc, const(char)* *argv);


/****************************************************************************
     PointerHash
 ****************************************************************************/
PointerHash* PointerHash_new();
void PointerHash_copy_(PointerHash* self, const(PointerHash)* other);
PointerHash* PointerHash_clone(PointerHash* self);
void PointerHash_free(PointerHash* self);
//void PointerHash_at_put_(PointerHash* self, void* k, void* v);
void PointerHash_removeKey_(PointerHash* self, void* k);
size_t PointerHash_size(PointerHash* self); // actually the keyCount;
size_t PointerHash_memorySize(PointerHash* self);
void PointerHash_compact(PointerHash* self);
void PointerHash_setSize_(PointerHash* self, size_t size);
void PointerHash_insert_(PointerHash* self, PointerHashRecord* x);
void PointerHash_grow(PointerHash* self);
//void PointerHash_shrinkIfNeeded(PointerHash* self);
void PointerHash_shrink(PointerHash* self);
void PointerHash_show(PointerHash* self);
void PointerHash_updateMask(PointerHash* self);


/****************************************************************************
     PointerHash_inline
 ****************************************************************************/
uint PointerHash_hash(PointerHash* self, void* key);
uint PointerHash_hash_more(PointerHash* self, uint hash);
PointerHashRecord* PointerHash_record1_(PointerHash* self, void* k);
PointerHashRecord* PointerHash_record2_(PointerHash* self, void* k);
void* PointerHash_at_(PointerHash* self, void* k);
size_t PointerHash_count(PointerHash* self);
int PointerHashKey_hasKey_(PointerHash* self, void* key);
void PointerHash_at_put_(PointerHash* self, void* k, void* v);
void PointerHash_shrinkIfNeeded(PointerHash* self);
void PointerHashRecord_swapWith_(PointerHashRecord* self, PointerHashRecord* other);
void PointerHash_clean(PointerHash* self);


/****************************************************************************
     PortableGettimeofday
 ****************************************************************************/
extern void gettimeofday(timeval* tv, timezone* tz);


/****************************************************************************
     PortableSorting
 ****************************************************************************/
void portable_qsort_r(void* base, size_t nel, size_t width,	void* context, PortableSortingCompareCallback compare);


/****************************************************************************
     PortableTruncate
 ****************************************************************************/
int truncate(const(char)* path, int length);


/****************************************************************************
     RandomGen
 ****************************************************************************/
RandomGen* RandomGen_new();
void RandomGen_free(RandomGen* self);
void RandomGen_setSeed(RandomGen* self, uint seed);
void RandomGen_chooseRandomSeed(RandomGen* self);
double RandomGen_randomDouble(RandomGen* self);
int RandomGen_randomInt(RandomGen* self);
double RandomGen_gaussian(RandomGen* self, double mean, double standardDeviation);


/****************************************************************************
     Stack
 ****************************************************************************/
Stack* Stack_new();
void Stack_free(Stack* self);
Stack* Stack_clone(const(Stack)* self);
void Stack_copy_(Stack* self, const(Stack)* other);
size_t Stack_memorySize(const(Stack)* self);
void Stack_compact(Stack* self);
void Stack_resize(Stack* self);
void Stack_popToMark_(Stack* self, intptr_t mark);
void Stack_makeMarksNull(Stack* self);
Stack* Stack_newCopyWithNullMarks(const(Stack)* self);
void Stack_do_on_(const(Stack)* self, StackDoOnCallback callback, void* target);
List* Stack_asList(const(Stack)* self);


/****************************************************************************
     Stack_inline
 ****************************************************************************/
void Stack_do_(const(Stack)* self, StackDoCallback callback);
void Stack_doUntilMark_(const(Stack)* self, StackDoCallback callback);
void Stack_clear(Stack* self);
size_t Stack_totalSize(const(Stack)* self);
int Stack_count(const(Stack)* self);
void Stack_push_(Stack* self, void* item);
void Stack_pushMark(Stack* self);
intptr_t Stack_pushMarkPoint(Stack* self);
void* Stack_pop(Stack* self);
void Stack_popMark(Stack* self);
int Stack_popMarkPoint_(Stack* self, intptr_t mark);
void Stack_clearTop(Stack* self);
void* Stack_top(const(Stack)* self);
void* Stack_at_(const(Stack)* self, int i);


/****************************************************************************
     UArray
 ****************************************************************************/
const(void)* UArray_data(const(UArray)* self);
const(uint8_t)* UArray_bytes(const(UArray)* self);
uint8_t* UArray_mutableBytes(UArray* self);
const(char)* UArray_asCString(const(UArray)* self);
size_t UArray_SizeOfCtype(CTYPE type);
const(char)* CTYPE_name(CTYPE type);
int CTYPE_forName(const(char)* name);
int CTYPE_fixedWidthTextEncodingForType(CTYPE type);
const(char)* CENCODING_name(CENCODING encoding);
int CENCODING_forName(const(char)* name);
int CENCODING_isText(CENCODING encoding);
void UArray_unsupported_with_(const(UArray)* self, const(char)* methodName, const(UArray)* other);
void UArray_error_(const(UArray)* self, char* e);
UArray* UArray_new();
UArray* UArray_newWithData_type_size_copy_(void* data, CTYPE type, size_t size, int copy);
UArray* UArray_newWithData_type_encoding_size_copy_(void* bytes, CTYPE type, CENCODING encoding, size_t size, int copy);
UArray* UArray_newWithCString_copy_(char* s, int copy);
UArray* UArray_newWithCString_(const(char)* s);
void UArray_setCString_(UArray* self, const(char)* s);
void UArray_setData_type_size_copy_(UArray* self, void* data, CTYPE type, size_t size, int copy);
UArray* UArray_clone(const(UArray)* self);
void UArray_show(const(UArray)* self);
void UArray_print(const(UArray)* self);
UArray UArray_stackAllocedWithData_type_size_(void* data, CTYPE type, size_t size);
UArray UArray_stackAllocedWithCString_(char* s);
UArray UArray_stackAllocedEmptyUArray();
void UArray_stackFree(UArray* self);
void UArray_free(UArray* self);
CTYPE UArray_itemType(const(UArray)* self);
size_t UArray_itemSize(const(UArray)* self);
void UArray_setItemType_(UArray* self, CTYPE type);
CENCODING UArray_encoding(const(UArray)* self);
void UArray_setEncoding_(UArray* self, CENCODING encoding);
void UArray_convertToEncoding_(UArray* self, CENCODING encoding);
void UArray_copyItems_(UArray* self, const(UArray)* other);
void UArray_copy_(UArray* self, const(UArray)* other);
void UArray_copyData_(UArray* self, const(UArray)* other);
void UArray_convertToItemType_(UArray* self, CTYPE newItemType);
void UArray_setSize_(UArray* self, size_t size);
size_t UArray_size(const(UArray)* self);
size_t UArray_sizeInBytes(const(UArray)* self);
void UArray_sizeTo_(UArray* self, size_t size);
UArray UArray_stackRange(const(UArray)* self, size_t start, size_t size);
UArray* UArray_range(const(UArray)* self, size_t start, size_t size);
UArray UArray_stackSlice(const(UArray)* self, int start, int end);
UArray* UArray_slice(const(UArray)* self, int start, int end);
int UArray_compare_(const(UArray)* self, const(UArray)* other);
int UArray_equals_(const(UArray)* self, const(UArray)* other);
int UArray_greaterThan_(const(UArray)* self, const(UArray)* other);
int UArray_lessThan_(const(UArray)* self, const(UArray)* other);
int UArray_greaterThanOrEqualTo_(const(UArray)* self, const(UArray)* other);
int UArray_lessThanOrEqualTo_(const(UArray)* self, const(UArray)* other);
int UArray_isZero(const(UArray)* self);
int UArray_contains_(const(UArray)* self, const(UArray)* other);
int UArray_containsAnyCase_(const(UArray)* self, const(UArray)* other);
int UArray_containsDouble_(const(UArray)* self, double other);
int UArray_containsLong_(const(UArray)* self, int other);
int UArray_find_(const(UArray)* self, const(UArray)* other);
int UArray_findAnyCase_(const(UArray)* self, const(UArray)* other);
int UArray_find_from_(const(UArray)* self, const(UArray)* other, size_t from);
int UArray_rFind_from_(const(UArray)* self, const(UArray)* other, size_t from);
int UArray_rFind_(const(UArray)* self, const(UArray)* other);
int UArray_rFindAnyCase_(const(UArray)* self, const(UArray)* other);
int UArray_rFindAnyValue_(const(UArray)* self, const(UArray)* other);
void UArray_at_putLong_(UArray* self, size_t pos, int v);
void UArray_at_putDouble_(UArray* self, size_t pos, double v);
void UArray_at_putPointer_(UArray* self, size_t pos, void* v);
void UArray_at_putAll_(UArray* self, size_t pos, const(UArray)* other);
void UArray_appendLong_(UArray* self, int v);
void UArray_appendDouble_(UArray* self, double v);
void UArray_appendPointer_(UArray* self, void* v);
void UArray_appendBytes_size_(UArray* self, const(uint8_t)* bytes, size_t size);
//void UArray_appendByte_(UArray* self, uint8_t byte);
void UArray_insert_every_(UArray* self, UArray* other, size_t itemCount);
void UArray_removeRange(UArray* self, size_t start, size_t size);
void UArray_leave_thenRemove_(UArray* self, size_t itemsToLeave, size_t itemsToRemove);
void UArray_removeFirst(UArray* self);
void UArray_removeLast(UArray* self);
void* UArray_rawPointerAt_(const(UArray)* self, size_t i);
int UArray_rawLongAt_(const(UArray)* self, size_t i);
double UArray_rawDoubleAt_(const(UArray)* self, size_t i);
void* UArray_pointerAt_(const(UArray)* self, size_t i);
int UArray_intAt_(const(UArray)* self, size_t i);
double UArray_doubleAt_(const(UArray)* self, size_t i);
int UArray_lastLong(const(UArray)* self);
int UArray_firstLong(const(UArray)* self);
int UArray_isFloatType(const(UArray)* self);
int UArray_isSignedType(const(UArray)* self);
size_t UArray_wrapPos_(const(UArray)* self, int pos);
void UArray_sort(UArray* self);
void UArray_sortBy_(UArray* self, UArraySortCallback cmp);


/****************************************************************************
     UArray_character
 ****************************************************************************/
void UArray_isalnum(UArray* self);
void UArray_isalpha(UArray* self);
void UArray_iscntrl(UArray* self);
void UArray_isdigit(UArray* self);
void UArray_isgraph(UArray* self);
void UArray_islower(UArray* self);
void UArray_isprint(UArray* self);
void UArray_ispunct(UArray* self);
void UArray_isspace(UArray* self);
void UArray_isupper(UArray* self);
void UArray_isxdigit(UArray* self);
void UArray_tolower(UArray* self);
void UArray_toupper(UArray* self);
int UArray_isLowercase(UArray* self);
int UArray_isUppercase(UArray* self);


/****************************************************************************
     UArray_format
 ****************************************************************************/
UArray* UArray_newWithFormat_(const(char)* format, ...);
UArray* UArray_newWithVargs_(const(char)* format, va_list ap);
UArray* UArray_fromFormat_(UArray* self, const(char)* format, ...);
void UArray_fromVargs_(UArray* self, const(char)* format, va_list ap);
UArray* UArray_asNewHexStringUArray(UArray* self);


/****************************************************************************
     UArray_math
 ****************************************************************************/
void UArray_clear(UArray* self);
void UArray_setItemsToLong_(UArray* self, int x);
void UArray_setItemsToDouble_(UArray* self, double x);
void UArray_rangeFill(UArray* self);
void UArray_negate(const(UArray)* self);
void UArray_add_(UArray* self, const(UArray)* other);
void UArray_subtract_(UArray* self, const(UArray)* other);
void UArray_multiply_(UArray* self, const(UArray)* other);
void UArray_divide_(UArray* self, const(UArray)* other);
double UArray_dotProduct_(const(UArray)* self, const(UArray)* other);
void UArray_addScalarDouble_(UArray* self, double v);
void UArray_subtractScalarDouble_(UArray* self, double v);
void UArray_multiplyScalarDouble_(UArray* self, double v);
void UArray_divideScalarDouble_(UArray* self, double v);
void UArray_bitwiseOr_(UArray* self, const(UArray)* other);
void UArray_bitwiseAnd_(UArray* self, const(UArray)* other);
void UArray_bitwiseXor_(UArray* self, const(UArray)* other);
void UArray_bitwiseNot(UArray* self);
void UArray_setAllBitsTo_(UArray* self, uint8_t aBool);
uint8_t UArray_byteAt_(UArray* self, size_t i);
int UArray_bitAt_(UArray* self, size_t i);
void UArray_setBit_at_(UArray* self, int b, size_t i);
UArray*  UArray_asBits(const(UArray)* self);
size_t UArray_bitCount(UArray* self);
void UArray_logicalOr_(UArray* self, const(UArray)* other);
void UArray_logicalAnd_(UArray* self, const(UArray)* other);
void UArray_sin(UArray* self);
void UArray_cos(UArray* self);
void UArray_tan(UArray* self);
void UArray_asin(UArray* self);
void UArray_acos(UArray* self);
void UArray_atan(UArray* self);
void UArray_sinh(UArray* self);
void UArray_cosh(UArray* self);
void UArray_tanh(UArray* self);
void UArray_exp(UArray* self);
void UArray_log(UArray* self);
void UArray_log10(UArray* self);
void UArray_sqrt(UArray* self);
void UArray_ceil(UArray* self);
void UArray_floor(UArray* self);
void UArray_abs(UArray* self);
void UArray_round(UArray* self);
void UArray_square(UArray* self);
void UArray_normalize(UArray* self);
void UArray_crossProduct_(UArray* self, const(UArray)* other);
double UArray_distanceTo_(const(UArray)* self, const(UArray)* other);
double UArray_sumAsDouble(const(UArray)* self);
double UArray_productAsDouble(const(UArray)* self);
double UArray_arithmeticMeanAsDouble(const(UArray)* self);
double UArray_arithmeticMeanSquareAsDouble(const(UArray)* self);
double UArray_maxAsDouble(const(UArray)* self);
double UArray_minAsDouble(const(UArray)* self);
void UArray_Max(UArray* self, const(UArray)* other);
void UArray_Min(UArray* self, const(UArray)* other);
void UArray_changed(UArray* self);
uintptr_t UArray_calcHash(UArray* self);
uintptr_t UArray_evenHash(UArray* self);
uintptr_t UArray_oddHash(UArray* self);
int UArray_equalsWithHashCheck_(UArray* self, UArray* other);
void UArray_duplicateIndexes(UArray* self);
void UArray_removeOddIndexes(UArray* self);
void UArray_removeEvenIndexes(UArray* self);
void UArray_reverseItemByteOrders(UArray* self);
void UArray_addEqualsOffsetXScaleYScale(UArray* self, UArray* other, float offset, float xscale, float yscale);


/****************************************************************************
     UArray_path
 ****************************************************************************/
void UArray_appendPath_(UArray* self, const(UArray)* path);
void UArray_removeLastPathComponent(UArray* self);
void UArray_clipBeforeLastPathComponent(UArray* self);
int UArray_findLastPathComponent(const(UArray)* self);
UArray* UArray_lastPathComponent(const(UArray)* self);
int UArray_findPathExtension(UArray* self);
void UArray_removePathExtension(UArray* self);
UArray* UArray_pathExtension(UArray* self);
UArray* UArray_fileName(UArray* self);
int UArray_OSPathSeparatorIsUnixSeparator();
UArray* UArray_asOSPath(UArray* self);
UArray* UArray_asUnixPath(UArray* self);


/****************************************************************************
     UArray_stream
 ****************************************************************************/
size_t UArray_fread_(UArray* self, FILE* fp);
int UArray_readFromCStream_(UArray* self, FILE* stream);
int UArray_readFromFilePath_(UArray* self, const(UArray)* path);
int UArray_readNumberOfItems_fromCStream_(UArray* self, size_t size, FILE* stream);
int UArray_readLineFromCStream_(UArray* self, FILE* stream);
size_t UArray_fwrite_(const(UArray)* self, size_t size, FILE* stream);
int UArray_writeToCStream_(const(UArray)* self, FILE* stream);
int UArray_writeToFilePath_(const(UArray)* self, const(UArray)* path);


/****************************************************************************
     UArray_string
 ****************************************************************************/
void UArray_append_(UArray* self, const(UArray)* other);
void UArray_appendCString_(UArray* self, const(char)* s);
void UArray_prepend_(UArray* self, const(UArray)* other);
int UArray_equalsAnyCase_(const(UArray)* self, const(UArray)* other);
void UArray_replace_with_(UArray* self, const(UArray)* a1, const(UArray)* a2);
void UArray_replaceAnyCase_with_(UArray* self, const(UArray)* a1, const(UArray)* a2);
void UArray_replaceCString_withCString_(UArray* self, const(char)* s1, const(char)* s2);
void UArray_remove_(UArray* self, const(UArray)* a1);
void UArray_removeAnyCase_(UArray* self, const(UArray)* a1);
int UArray_clipBefore_(UArray* self, const(UArray)* other);
int UArray_clipBeforeEndOf_(UArray* self, const(UArray)* other);
int UArray_clipAfter_(UArray* self, const(UArray)* other);
int UArray_clipAfterStartOf_(UArray* self, const(UArray)* other);
void UArray_lstrip_(UArray* self, const(UArray)* other);
void UArray_rstrip_(UArray* self, const(UArray)* other);
void UArray_strip_(UArray* self, const(UArray)* other);
void UArray_swapIndex_withIndex_(UArray* self, size_t i, size_t j);
void UArray_reverse(UArray* self);
//size_t UArray_matchingPref_ixSizeWith_(const(UArray)* self, const(UArray)* other);
PtrUArray* UArray_split_(const(UArray)* self, const(PtrUArray)* delims);
size_t UArray_splitCount_(const(UArray)* self, const(PtrUArray)* delims);
int UArray_beginsWith_(UArray* self, const(UArray)* other);
int UArray_endsWith_(UArray* self, const(UArray)* other);
void UArray_swapWith_(UArray* self, UArray* other);
void UArray_escape(UArray* self);
void UArray_unescape(UArray* self);
void UArray_quote(UArray* self);
void UArray_unquote(UArray* self);
void UArray_translate(UArray* self, UArray* fromChars, UArray* toChars);
size_t UArray_count_(const(UArray)* self, const(UArray)* other);
UArray* UArray_asBase64(const(UArray)* self, int charsPerLine);
UArray* UArray_fromBase64(const(UArray)* self);


/****************************************************************************
     UArray_utf
 ****************************************************************************/
int UArray_convertToFixedSizeType(UArray* self);
size_t UArray_numberOfCharacters(const(UArray)* self); // returns 0 on error;
int UArray_maxCharSize(const(UArray)* self);
int UArray_isMultibyte(const(UArray)* self);
int UArray_isLegalUTF8(const(UArray)* self);
UArray* UArray_asUTF8(const(UArray)* self);
UArray* UArray_asUCS2(const(UArray)* self);
UArray* UArray_asUCS4(const(UArray)* self);
void UArray_convertToUTF8(UArray* self);
void UArray_convertToUCS2(UArray* self);
void UArray_convertToUCS4(UArray* self);


/****************************************************************************
     Coro
 ****************************************************************************/
Coro* Coro_new();
void Coro_free(Coro* self);
void* Coro_stack(Coro* self);
size_t Coro_stackSize(Coro* self);
void Coro_setStackSize_(Coro* self, size_t sizeInBytes);
size_t Coro_bytesLeftOnStack(Coro* self);
int Coro_stackSpaceAlmostGone(Coro* self);
void Coro_initializeMainCoro(Coro* self);
void Coro_startCoro_(Coro* self, Coro* other, void* context, CoroStartCallback callback);
void Coro_switchTo_(Coro* self, Coro* next);
void Coro_setup(Coro* self, void* arg); // private;


/****************************************************************************
     Collector
 ****************************************************************************/
Collector* Collector_new();
void Collector_free(Collector* self);
void Collector_check(Collector* self);
void Collector_checkObjectPointers(Collector* self); // if not 0, then memory is hosed;
void Collector_checkObjectsWith_(Collector* self, CollectorCheckFunc* func);
void Collector_setMarkBeforeSweepValue_(Collector* self, void* v);
void Collector_setMarkFunc_(Collector* self, CollectorMarkFunc* func);
void Collector_setWillFreeFunc_(Collector* self, CollectorWillFreeFunc* func);
void Collector_setFreeFunc_(Collector* self, CollectorFreeFunc* func);
void Collector_setMarksPerAlloc_(Collector* self, float n);
float Collector_marksPerAlloc(Collector* self);
void Collector_setAllocatedStep_(Collector* self, float n);
float Collector_allocatedStep(Collector* self);
void Collector_setAllocsPerSweep_(Collector* self, int n);
float Collector_allocsPerSweep(Collector* self);
void Collector_setDebug_(Collector* self, int b);
void Collector_setSafeModeOn_(Collector* self, int b);
void* Collector_retain_(Collector* self, void* v);
void Collector_stopRetaining_(Collector* self, void* v);
void Collector_removeAllRetainedValues(Collector* self);
CollectorMarker* Collector_newMarker(Collector* self);
void Collector_addValue_(Collector* self, void* v);
void Collector_initPhase(Collector* self);
size_t Collector_sweep(Collector* self);
size_t Collector_sweepPhase(Collector* self);
void Collector_markPhase(Collector* self);
size_t Collector_collect(Collector* self);
size_t Collector_freeAllValues(Collector* self);
char* Collector_colorNameFor_(Collector* self, void* v);
void Collector_pushPause(Collector* self);
void Collector_popPause(Collector* self);
int Collector_isPaused(Collector* self);
double Collector_timeUsed(Collector* self);


/****************************************************************************
     CollectorMarker
 ****************************************************************************/
CollectorMarker* CollectorMarker_new();
void CollectorMarker_free(CollectorMarker* self);


/****************************************************************************
     CollectorMarker_inline
 ****************************************************************************/
void CollectorMarker_clear(CollectorMarker* self);
void CollectorMarker_insertAfter_(CollectorMarker* self, CollectorMarker* other);
void CollectorMarker_insertBefore_(CollectorMarker* self, CollectorMarker* other);
void CollectorMarker_remove(CollectorMarker* self);
void CollectorMarker_removeAndInsertAfter_(CollectorMarker* self, CollectorMarker* other);
void CollectorMarker_removeAndInsertBefore_(CollectorMarker* self, CollectorMarker* other);
void CollectorMarker_removeIfNeededAndInsertAfter_(CollectorMarker* self, CollectorMarker* other);
int CollectorMarker_isEmpty(CollectorMarker* self);


/****************************************************************************
     Collector_inline
 ****************************************************************************/
int Collector_markerIsWhite_(Collector* self, CollectorMarker* m);
int Collector_markerIsGray_(Collector* self, CollectorMarker* m);
int Collector_markerIsBlack_(Collector* self, CollectorMarker* m);
void Collector_makeFree_(Collector* self, CollectorMarker* v);
void Collector_makeWhite_(Collector* self, CollectorMarker* v);
void Collector_makeGray_(Collector* self, CollectorMarker* v);
void Collector_makeBlack_(Collector* self, CollectorMarker* v);
void Collector_makeGrayIfWhite_(Collector* self, void* v);
void Collector_makeFreed_(Collector* self, void* v);
void* Collector_value_addingRefTo_(Collector* self, void* v, void* ref_);


/****************************************************************************
     IoCFunction
 ****************************************************************************/
IoCFunction* IoCFunction_proto(void* state);
void IoCFunction_protoFinish(void* state);
IoCFunction* IoCFunction_rawClone(IoCFunction* self);
IoCFunction* IoCFunction_newWithFunctionPointer_tag_name_(void* state, IoUserFunction s, IoTag* typeTag, const(char)* name);
void IoCFunction_mark(IoCFunction* self);
void IoCFunction_free(IoCFunction* self);
void IoCFunction_print(IoCFunction* self);
IoObject* IoCFunction_id(IoCFunction* self, IoObject* locals, IoMessage* m);
IoObject* IoCFunction_uniqueName(IoCFunction* self, IoObject* locals, IoMessage* m);
IoObject* IoCFunction_typeName(IoCFunction* self, IoObject* locals, IoMessage* m);
IoObject* IoCFunction_equals(IoCFunction* self, IoObject* locals, IoMessage* m);
IoObject* IoCFunction_activate(IoCFunction* self, IoObject* target, IoObject* locals, IoMessage* m, IoObject* slotContext);
IoObject* IoCFunction_performOn(IoCFunction* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoCoroutine
 ****************************************************************************/
IoCoroutine* IoCoroutine_proto(void* state);
void IoCoroutine_protoFinish(IoCoroutine* self);
IoCoroutine* IoCoroutine_rawClone(IoCoroutine* self);
IoCoroutine* IoCoroutine_new(void* state);
void IoCoroutine_free(IoCoroutine* self);
void IoCoroutine_mark(IoCoroutine* self);
void IoCoroutine_rawShow(IoCoroutine* self);
IoObject* IoCoroutine_main(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_freeStack(IoCoroutine* self, IoObject* locals, IoMessage* m);
void* IoCoroutine_cid(IoCoroutine* self);
IoObject* IoCoroutine_setLabel(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_label(IoCoroutine* self, IoObject* locals, IoMessage* m);
void IoCoroutine_rawSetRunTarget_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawRunTarget(IoCoroutine* self);
void IoCoroutine_rawSetRunMessage_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawRunMessage(IoCoroutine* self);
void IoCoroutine_rawSetRunLocals_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawRunLocals(IoCoroutine* self);
void IoCoroutine_rawSetParentCoroutine_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawParentCoroutine(IoCoroutine* self);
void IoCoroutine_rawSetResult_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawResult(IoCoroutine* self);
void IoCoroutine_rawRemoveException(IoCoroutine* self);
void IoCoroutine_rawSetException_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawException(IoCoroutine* self);
IoObject* IoCoroutine_ioStack(IoCoroutine* self, IoObject* locals, IoMessage* m);
int IoCoroutine_rawIoStackSize(IoCoroutine* self);
void IoCoroutine_rawRun(IoCoroutine* self);
void IoCoroutine_clearStack(IoCoroutine* self);
void IoCoroutine_try(IoCoroutine* self, IoObject* target, IoObject* locals, IoMessage* message);
IoCoroutine* IoCoroutine_newWithTry(void* state, IoObject* target, IoObject* locals, IoMessage* message);
void IoCoroutine_raiseError(IoCoroutine* self, IoSymbol* description, IoMessage* m);
IoObject* IoCoroutine_implementation(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_run(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_callStack(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_isCurrent(IoCoroutine* self, IoObject* locals, IoMessage* m);
void IoCoroutine_rawSetRunTarget_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawRunTarget(IoCoroutine* self);
void IoCoroutine_rawSetRunMessage_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawRunMessage(IoCoroutine* self);
void IoCoroutine_rawSetParentCoroutine_(IoCoroutine* self, IoObject* v);
IoObject* IoCoroutine_rawParentCoroutine(IoCoroutine* self);
IoObject* IoCoroutine_start(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_rawResume(IoCoroutine* self);
IoObject* IoCoroutine_resume(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_isCurrent(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_currentCoroutine(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_callStack(IoCoroutine* self);
void IoObject_appendStackEntryDescription(IoCoroutine* self, UArray* ba);
void IoCoroutine_rawPrint(IoCoroutine* self);
int IoCoroutine_rawDebuggingOn(IoCoroutine* self);
IoObject* IoCoroutine_setMessageDebugging(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_performWithDebugger(IoCoroutine* self, IoObject* locals, IoMessage* m);
IoObject* IoCoroutine_callStack(IoCoroutine* self, IoObject* locals, IoMessage* m);
void IoCoroutine_rawPrintBackTrace(IoCoroutine* self);


/****************************************************************************
     IoDirectory
 ****************************************************************************/
IoDirectory* IoDirectory_rawClone(IoDirectory* self);
IoDirectory* IoDirectory_proto(void* state);
IoDirectory* IoDirectory_new(void* state);
IoDirectory* IoDirectory_newWithPath_(void* state, IoSymbol* path);
IoDirectory* IoDirectory_cloneWithPath_(IoDirectory* self, IoSymbol* path);
void IoDirectory_free(IoDirectory* self);
void IoDirectory_mark(IoDirectory* self);
IoObject* IoDirectory_path(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_setPath(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_name(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_at(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_size(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_exists(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_items(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_create(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_createSubdirectory(IoDirectory* self, IoObject* locals, IoMessage* m);
UArray* IoDirectory_CurrentWorkingDirectoryAsUArray();
int IoDirectory_SetCurrentWorkingDirectory(const(char)* path);
IoObject* IoDirectory_currentWorkingDirectory(IoDirectory* self, IoObject* locals, IoMessage* m);
IoObject* IoDirectory_setCurrentWorkingDirectory(IoDirectory* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoError
 ****************************************************************************/
IoObject* IoError_newWithMessageFormat_(void* state, const(char)* format, ...);
IoObject* IoError_newWithCStringMessage_(IoState* state, char* cString);


/****************************************************************************
     IoFile
 ****************************************************************************/
IoFile* IoFile_proto(void* state);
IoFile* IoFile_rawClone(IoFile* self);
IoFile* IoFile_new(void* state);
IoFile* IoFile_newWithPath_(void* state, IoSymbol* path);
IoFile* IoFile_cloneWithPath_(IoFile* self, IoSymbol* path);
IoFile* IoFile_newWithStream_(void* state, FILE* stream);


/****************************************************************************
     IoList
 ****************************************************************************/
IoList* IoList_proto(void* state);
IoList* IoList_rawClone(IoList* self);
IoList* IoList_new(void* state);
IoList* IoList_newWithList_(void* state, List* list);
void IoList_free(IoList* self);
void IoList_mark(IoList* self);
int IoList_compare(IoList* self, IoList* otherList);
//void IoList_writeToStream_(IoList* self, BStream* stream);
//void IoList_readFromStream_(IoList* self, BStream* stream);
List* IoList_rawList(IoList* self);
IoObject* IoList_rawAt_(IoList* self, int i);
void IoList_rawAt_put_(IoList* self, int i, IoObject* v);
void IoList_rawAppend_(IoList* self, IoObject* v);
void IoList_rawRemove_(IoList* self, IoObject* v);
void IoList_rawAddIoList_(IoList* self, IoList* other);
void IoList_rawAddBaseList_(IoList* self, List* other);
size_t IoList_rawSize(IoList* self);
IoObject* IoList_with(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_indexOf(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_contains(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_containsIdenticalTo(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_capacity(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_size(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_at(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_first(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_last(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_slice(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_sliceInPlace(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_mapInPlace(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_map(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_select(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_detect(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_foreach(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_reverseForeach(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_preallocateToSize(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_append(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_prepend(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_appendIfAbsent(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_appendSeq(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_remove(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_push(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_pop(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_removeAll(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_atInsert(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_removeAt(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_atPut(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_removeAll(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_swapIndices(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_reverseInPlace(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_sortInPlace(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_sortInPlaceBy(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_selectInPlace(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_asEncodedList(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_fromEncodedList(IoList* self, IoObject* locals, IoMessage* m);
IoObject* IoList_join(IoList* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoMap
 ****************************************************************************/
IoMap* IoMap_rawClone(IoMap* self);
IoMap* IoMap_new(void* state);
PHash* IoMap_rawHash(IoMap* self);
IoObject* IoMap_rawAt(IoMap* self, IoSymbol* k);
IoObject* IoMap_at(IoMap* self, IoObject* locals, IoMessage* m);
void IoMap_rawAtPut(IoMap* self, IoSymbol* k, IoObject* v);
IoList* IoMap_rawKeys(IoMap* self);


/****************************************************************************
     IoMessage
 ****************************************************************************/
IoMessage* IoMessage_proto(void* state);
IoMessage* IoMessage_rawClone(IoMessage* m);
IoMessage* IoMessage_new(void* state);
void IoMessage_copy_(IoMessage* self, IoMessage* other);
IoMessage* IoMessage_deepCopyOf_(IoMessage* m);
IoMessage* IoMessage_newWithName_(void* state, IoSymbol* symbol);
IoMessage* IoMessage_newWithName_label_(void* state, IoSymbol* symbol, IoSymbol* label);
IoMessage* IoMessage_newWithName_returnsValue_(void* state, IoSymbol* symbol, IoObject* v);
IoMessage* IoMessage_newWithName_andCachedArg_(void* state, IoSymbol* symbol, IoObject* v);
void IoMessage_mark(IoMessage* self);
void IoMessage_free(IoMessage* self);
IoSymbol* IoMessage_rawLabel(IoMessage* self);
int IoMessage_rawLineNumber(IoMessage* self);
int IoMessage_rawCharNumber(IoMessage* self);
void IoMessage_label_(IoMessage* self, IoSymbol* ioSymbol); // sets label for children too;
void IoMessage_rawSetLineNumber_(IoMessage* self, int n);
void IoMessage_rawSetCharNumber_(IoMessage* self, int n);
void IoMessage_rawCopySourceLocation(IoMessage* self, IoMessage* other);
List* IoMessage_rawArgList(IoMessage* self);
ubyte IoMessage_needsEvaluation(IoMessage* self);
void IoMessage_addCachedArg_(IoMessage* self, IoObject* v);
void IoMessage_setCachedArg_to_(IoMessage* self, int n, IoObject* v);
void IoMessage_setCachedArg_toInt_(IoMessage* self, int n, int anInt);
void IoMessage_rawSetCachedResult_(IoMessage* self, IoObject* v);
void IoMessage_rawSetName_(IoMessage* self, IoObject* v);
void IoMessage_rawSetLabel_(IoMessage* self, IoObject* v);
IoObject* IoMessage_lineNumber(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_characterNumber(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_label(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_doInContext(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_locals_performOn_(IoMessage* self, IoObject* locals, IoObject* target);
//IoObject* IoMessage_locals_valueArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_valueOrEvalArgAt_(IoMessage* self, IoObject* locals, int n);
void IoMessage_assertArgCount_receiver_(IoMessage* self, int n, IoObject* receiver);
int IoMessage_argCount(IoMessage* self);
void IoMessage_locals_numberArgAt_errorForType_( IoMessage* self, IoObject* locals, int n, const(char)* typeName);
IoObject* IoMessage_locals_numberArgAt_(IoMessage* self, IoObject* locals, int n);
int IoMessage_locals_intArgAt_(IoMessage* self, IoObject* locals, int n);
int IoMessage_locals_boolArgAt_(IoMessage* self, IoObject* locals, int n);
int IoMessage_locals_intArgAt_(IoMessage* self, IoObject* locals, int n);
size_t IoMessage_locals_sizetArgAt_(IoMessage* self, IoObject* locals, int n);
double IoMessage_locals_doubleArgAt_(IoMessage* self, IoObject* locals, int n);
float IoMessage_locals_floatArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_symbolArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_seqArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_mutableSeqArgAt_(IoMessage* self, IoObject* locals, int n);
char* IoMessage_locals_cStringArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_valueAsStringArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_blockArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_dateArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_mapArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_messageArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_listArgAt_(IoMessage* self, IoObject* locals, int n);
void IoMessage_print(IoMessage* self);
void IoMessage_printWithReturn(IoMessage* self);
UArray* IoMessage_description(IoMessage* self);
UArray* IoMessage_descriptionJustSelfAndArgs(IoMessage* self); /* caller must io_free returned */;
void IoMessage_appendDescriptionTo_follow_(IoMessage* self, UArray* ba, int follow);
IoObject* IoMessage_asString(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_clone(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_protoName(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_protoSetName(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_descriptionString(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_next(IoMessage* self, IoObject* locals, IoMessage* m);
IoMessage* IoMessage_rawNext(IoMessage* self);
IoObject* IoMessage_setNext(IoMessage* self, IoObject* locals, IoMessage* m);
void IoMessage_rawSetNext_(IoMessage* self, IoMessage* m);
IoObject* IoMessage_isEOL(IoMessage* self, IoObject* locals, IoMessage* m);
int IoMessage_rawIsEOL(IoMessage* self);
IoObject* IoMessage_nextIgnoreEOLs(IoMessage* self, IoObject* locals, IoMessage* m);
IoMessage* IoMessage_rawNextIgnoreEOLs(IoMessage* self);
IoObject* IoMessage_last(IoMessage* self, IoObject* locals, IoMessage* m);
IoMessage* IoMessage_rawLast(IoMessage* self);
IoObject* IoMessage_lastBeforeEOL(IoMessage* self, IoObject* locals, IoMessage* m);
IoMessage* IoMessage_rawLastBeforeEOL(IoMessage* self);
IoObject* IoMessage_previous(IoMessage* self, IoObject* locals, IoMessage* m);
IoMessage* IoMessage_rawPrevious(IoMessage* self);
IoObject* IoMessage_setPrevious(IoMessage* self, IoObject* locals, IoMessage* m);
void IoMessage_rawSetPrevious(IoMessage* self, IoMessage* m);
IoObject* IoMessage_argAt(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_arguments(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_setArguments(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_appendArg(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_appendCachedArg(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_argCount_(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_cachedResult(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_setCachedResult(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_removeCachedResult(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_hasCachedResult(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_setLineNumber(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_setCharacterNumber(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_setLabel(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_fromString(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_argsEvaluatedIn(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_evaluatedArgs(IoMessage* self, IoObject* locals, IoMessage* m);
IoObject* IoMessage_profilerTime(IoMessage* self, IoObject* locals, IoMessage* m);
void IoMessage_foreachArgs(IoMessage* self,	IoObject* object,	IoSymbol* *indexSlotName,	IoSymbol* *valueSlotName,	IoMessage* *doMessage);
IoMessage* IoMessage_asMessageWithEvaluatedArgs(IoMessage* self, IoObject* locals, IoMessage* m);
void IoMessage_addArg_(IoMessage* self, IoMessage* m);
IoMessage* IoMessage_rawArgAt_(IoMessage* self, int n);
List* IoMessage_rawArgs(IoMessage* self);
UArray* IoMessage_asMinimalStackEntryDescription(IoMessage* self);


/****************************************************************************
     IoMessage_inline
 ****************************************************************************/
IoSymbol* IoMessage_name(IoMessage* self);
void IoMessage_addArg_(IoMessage* self, IoMessage* m);
IoMessage* IoMessage_rawArgAt_(IoMessage* self, int n);
IoSymbol* IoMessage_rawLabel(IoMessage* self);
List* IoMessage_rawArgs(IoMessage* self);
IoObject* IoMessage_name(IoMessage* self);


/****************************************************************************
     IoNumber
 ****************************************************************************/
IoNumber* IoNumber_proto(void* state);
IoNumber* IoNumber_rawClone(IoNumber* self);
IoNumber* IoNumber_newWithDouble_(void* state, double n);
IoNumber* IoNumber_newCopyOf_(IoNumber* number);
void IoNumber_copyFrom_(IoNumber* self, IoNumber* number);
//void IoNumber_writeToStream_(IoNumber* self, BStream* stream);
//void* IoNumber_readFromStream_(IoNumber* self, BStream* stream);
void IoNumber_free(IoNumber* self);
UArray IoNumber_asStackUArray(IoNumber* self);
int IoNumber_asInt(IoNumber* self);
double IoNumber_asDouble(IoNumber* self);
float IoNumber_asFloat(IoNumber* self);
int IoNumber_compare(IoNumber* self, IoNumber* v);
void IoNumber_print(IoNumber* self);
IoObject* IoNumber_htonl(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_ntohl(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asNumber(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_add_(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_subtract(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_divide(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_multiply(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_printNumber(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asBuffer(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asString(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_justAsString(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asCharacter(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asUint32Buffer(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_abs(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_acos(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asin(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_atan(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_atan2(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_ceil(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_cos(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_deg(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_exp(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_factorial(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_floor(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_log(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_log2(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_log10(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_max(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_min(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_mod(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_pow(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_round(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_roundDown(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_sin(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_sqrt(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_squared(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_cubed(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_tan(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_random(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_gaussianRandom(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_randomseed(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_toggle(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_newBitwiseAnd(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_newBitwiseOr(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_bitwiseAnd(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_bitwiseOr(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_bitwiseXor(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_bitwiseComplement(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_bitShiftLeft(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_bitShiftRight(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isEven(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isOdd(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isAlphaNumeric(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isLetter(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isControlCharacter(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isDigit(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isGraph(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isLowercase(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isUppercase(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isPrint(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isPunctuation(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isSpace(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isHexDigit(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asLowercase(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_asUppercase(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_between(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_clip(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_negate(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_at(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_integerMax(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_integerMin(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_intMax(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_intMin(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_shortMax(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_shortMin(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_uintLongMax(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_uintIntMax(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_floatMax(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_floatMin(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_isNan(IoNumber* self, IoObject* locals, IoMessage* m);
IoObject* IoNumber_repeat(IoNumber* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoObject
 ****************************************************************************/
IoObject* IoObject_proto(void* state);
IoObject* IoObject_protoFinish(void* state);
IoObject* IoObject_localsProto(void* state);
IoObject* IOCLONE(IoObject* self);
IoObject* IoObject_rawClone(IoObject* self);
IoObject* IoObject_justClone(IoObject* self);
IoObject* IoObject_rawClonePrimitive(IoObject* self);
IoObject* IoObject_new(void* state);
IoObject* IoObject_addMethod_(IoObject* self, IoSymbol* slotName, IoMethodFunc fp);
void IoObject_addMethodTable_(IoObject* self, IoMethodTable* methodTable);
IoObject* IoObject_addTaglessMethod_(IoObject* self, IoSymbol* slotName, IoMethodFunc fp);
void IoObject_addTaglessMethodTable_(IoObject* self, IoMethodTable* methodTable);
void IoObject_dealloc(IoObject* self);
void IoObject_willFree(IoObject* self);
void IoObject_free(IoObject* self);
int IoObject_hasProtos(IoObject* self);
int IoObject_rawProtosCount(IoObject* self);
void IoObject_rawAppendProto_(IoObject* self, IoObject* p);
void IoObject_rawPrependProto_(IoObject* self, IoObject* p);
void IoObject_rawRemoveProto_(IoObject* self, IoObject* p);
//void IoObject_rawRemoveAllProtos(IoObject* self);
void IoObject_rawSetProto_(IoObject* self, IoObject* proto);
IoObject* IoObject_objectProto(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_setProto(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_setProtos(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_appendProto(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_prependProto(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_removeProto(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_removeAllProtos(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protosMethod(IoObject* self, IoObject* locals, IoMessage* m);
uint IoObject_rawHasProto_(IoObject* self, IoObject* p);
void IoObject_createSlots(IoObject* self);
void IoObject_setSlot_to_(IoObject* self, IoSymbol* slotName, IoObject* value);
IoObject* IoObject_getSlot_(IoObject* self, IoSymbol* slotName);
IoObject* IoObject_symbolGetSlot_(IoObject* self, IoSymbol* slotName);
IoObject* IoObject_seqGetSlot_(IoObject* self, IoSymbol* slotName);
double IoObject_doubleGetSlot_(IoObject* self, IoSymbol* slotName);
void IoObject_removeSlot_(IoObject* self, IoSymbol* slotName);
//IoObject* IoObject_activate(IoObject* self, IoObject* target, IoObject* locals, IoMessage* m, IoObject* slotContext);
//IoObject* IoObject_perform(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_localsForward(IoObject* self, IoObject* locals, IoMessage* m);
int IoObject_compare(IoObject* self, IoObject* v);
int IoObject_defaultCompare(IoObject* self, IoObject* v);
const(char)* IoObject_name(IoObject* self);
void IoObject_print(IoObject* self);
size_t IoObject_memorySize(IoObject* self);
void IoObject_compact(IoObject* self);
char* IoObject_markColorName(IoObject* self);
void IoObject_show(IoObject* self);
IoObject* IoObject_clone(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_cloneWithoutInit(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_shallowCopy(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_initClone_(IoObject* self, IoObject* locals, IoMessage* m, IoObject* newObject);
IoObject* IoObject_protoWrite(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoWriteLn(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoPerform(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoPerformWithArgList(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoSet_to_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoSetSlotWithType(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_localsUpdateSlot(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoUpdateSlot_to_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoGetSlot_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoGetLocalSlot_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoHasLocalSlot(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoHasProto_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoRemoveSlot(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoRemoveAllSlots(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoSlotNames(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoSlotValues(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_super(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_contextWithSlot(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_ancestorWithSlot(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_doMessage(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_self(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_locals(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_thisMessage(IoObject* self, IoObject* locals, IoMessage* m);
int IoObject_rawCheckMemory(IoObject* self);
IoObject* IoObject_memorySizeMethod(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_compactMethod(IoObject* self, IoObject* locals, IoMessage* m);
void IoObject_defaultPrint(IoObject* self);
IoObject* IoObject_type(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_lobbyPrint(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_and(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_subtract(IoObject* self, IoObject* locals, IoMessage* m);
int IoObject_sortCompare(IoObject* *self, IoObject* *v);
IoObject* IoObject_isIdenticalTo(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_equals(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_notEquals(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_protoCompare(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_isLessThan_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_isLessThanOrEqualTo_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_isGreaterThan_(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_isGreaterThanOrEqualTo_(IoObject* self, IoObject* locals, IoMessage* m);
//IoObject* IoObject_truthValueOfArg(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_evalArg(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_evalArgAndReturnNil(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_evalArgAndReturnSelf(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_uniqueId(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_do(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_lexicalDo(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_message(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_rawDoString_label_(IoObject* self, IoSymbol* string, IoSymbol* label);
IoObject* IoObject_doString(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_doFile(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_setIsActivatableMethod(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_isActivatableMethod(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_rawDoMessage(IoObject* self, IoMessage* m);
IoObject* IoObject_eval(IoObject* self, IoMessage* m, IoObject* locals);
IoObject* IoObject_argIsActivationRecord(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_argIsCall(IoObject* self, IoObject* locals, IoMessage* m);
UArray* IoObject_rawGetUArraySlot(IoObject* self, IoObject* locals, IoMessage* m, IoSymbol* slotName);
UArray* IoObject_rawGetMutableUArraySlot(IoObject* self, IoObject* locals, IoMessage* m, IoSymbol* slotName);
IoObject* IoObject_become(IoObject* self, IoObject* locals, IoMessage* m);
void IoObject_addListener_(IoObject* self, void* listener);
void IoObject_removeListener_(IoObject* self, void* listener);
void IoObject_protoClean(IoObject* self);
IoObject* IoObject_hasDirtySlot_(IoObject* self, IoMessage* m, IoObject* locals);
IoObject* IoObject_markClean(IoObject* self, IoObject* locals, IoMessage* m);
// //PID_TYPE IoObject_pid(IoObject* self);
IoSeq* IoObject_asString_(IoObject* self, IoMessage* m);


/****************************************************************************
     IoObject_inline
 ****************************************************************************/
PHashRecord* PHash_record1_(PHash* self, void* k);
PHashRecord* PHash_record2_(PHash* self, void* k);
void* PHash_at_(PHash* self, void* k);
uint PHash_count(PHash* self);
int PHashKey_hasKey_(PHash* self, void* key);
void PHash_at_put_(PHash* self, void* k, void* v);
void PHash_shrinkIfNeeded(PHash* self);
void PHashRecord_swapWith_(PHashRecord* self, PHashRecord* other);
void PHash_clean(PHash* self);
PHash* IoObject_slots(IoObject* self);
void IoObject_slots_(IoObject* self, PHash* v);
IoObject* *IoObject_protos(IoObject* self);
void IoObject_protos_(IoObject* self, IoObject* *v);
int IoObject_isWhite(IoObject* self);
int IoObject_isGray(IoObject* self);
int IoObject_isBlack(IoObject* self);
void IoObject_createSlotsIfNeeded(IoObject* self);
void IoObject_rawRemoveAllProtos(IoObject* self);
void IoObject_shouldMark(IoObject* self);
void IoObject_shouldMarkIfNonNull(IoObject* self);
void IoObject_freeIfUnref_erenced(IoObject* self);
IoObject* IoObject_addingRef_(IoObject* self, IoObject* ref_);
void IoObject_inlineSetSlot_to_(IoObject* self, IoSymbol* slotName, IoObject* value);
IoObject* IoObject_rawGetSlot_context_(IoObject* self, IoSymbol* slotName, IoObject* *context);
IoObject* IoObject_rawGetSlot_(IoObject* self, IoSymbol* slotName);
int IoObject_mark(IoObject* self);
int IoObject_hasCloneFunc_(IoObject* self, IoTagCloneFunc func);
//int IoObject_hasCloneFunc_(IoObject* self, IoTagCloneFunc func);
//IoObject* IoObject_activate(IoObject* self,IoObject* IoObject_activate(IoObject* self, IoObject* target, IoObject* locals, IoMessage* m, IoObject* slotContext);
IoObject* IoObject_activate(IoObject* self, IoObject* target, IoObject* locals, IoMessage* m, IoObject* slotContext);
IoObject* IoObject_forward(IoObject* self, IoObject* locals, IoMessage* m);
IoObject* IoObject_perform(IoObject* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoSeq
 ****************************************************************************/
int ISMUTABLESEQ(IoObject* self);
int ioSeqCompareFunc(void* s1, void* s2);
int ioSymbolFindFunc(void* s, void* ioSymbol);
int IoObject_isStringOrBuffer(IoObject* self);
int IoObject_isNotStringOrBuffer(IoObject* self);
IoSeq* IoSeq_proto(void* state);
IoSeq* IoSeq_protoFinish(IoSeq* self);
IoSeq* IoSeq_rawClone(IoSeq* self);
IoSeq* IoSeq_new(void* state);
IoSeq* IoSeq_newWithUArray_copy_(void* state, UArray* ba, int copy);
IoSeq* IoSeq_newWithData_length_(void* state, const(ubyte)* s, size_t length);
IoSeq* IoSeq_newWithCString_length_(void* state, const(char)* s, size_t length);
IoSeq* IoSeq_newWithCString_(void* state, const(char)* s);
IoSeq* IoSeq_newFromFilePath_(void* state, const(char)* path);
IoSeq* IoSeq_rawMutableCopy(IoSeq* self);
IoSymbol* IoSeq_newSymbolWithCString_(void* state, const(char)* s);
IoSymbol* IoSeq_newSymbolWithData_length_(void* state, const(char)* s, size_t length);
IoSymbol* IoSeq_newSymbolWithUArray_copy_(void* state, UArray* ba, int copy);
IoSymbol* IoSeq_newSymbolWithFormat_(void* state, const(char)* format, ...);
void IoSeq_free(IoSeq* self);
int IoSeq_compare(IoSeq* self, IoSeq* v);
char* IoSeq_asCString(IoSeq* self);
ubyte* IoSeq_rawBytes(IoSeq* self);
//UArray* IoSeq_rawUArray(IoSeq* self);
IoSymbol* IoSeq_rawAsUntriquotedSymbol(IoSeq* self);
size_t IoSeq_rawSize(IoSeq* self);
size_t IoSeq_rawSizeInBytes(IoSeq* self);
void IoSeq_rawSetSize_(IoSeq* self, size_t size);
double IoSeq_asDouble(IoSeq* self);
IoSymbol* IoSeq_rawAsSymbol(IoSeq* self);
IoSymbol* IoSeq_rawAsUnquotedSymbol(IoSeq* self);
IoSymbol* IoSeq_rawAsUnescapedSymbol(IoSeq* self);
int IoSeq_rawEqualsCString_(IoSeq* self, const(char)* s);
double IoSeq_rawAsDoubleFromHex(IoSeq* self);
double IoSeq_rawAsDoubleFromOctal(IoSeq* self);


/****************************************************************************
     IoSeq_immutable
 ****************************************************************************/
void IoSeq_rawPrint(IoSeq* self);
void IoSeq_addImmutableMethods(IoSeq* self);
IoObject* IoSeq_with(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_itemType(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_itemSize(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_encoding(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asUTF8(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asUCS2(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asUCS4(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asFixedSizeType(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asBinaryNumber(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asSymbol(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_isMutable(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_isSymbol(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asNumber(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_whiteSpaceStrings(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_print(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_linePrint(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_size(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_sizeInBytes(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_isEmpty(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_isZero(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_at(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_exclusiveSlice(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_inclusiveSlice(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_between(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asNumber(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_findSeqs(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_findSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_reverseFindSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_beginsWithSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_endsWithSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_split(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_contains(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_containsSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_containsAnyCaseSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_isLowercase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_isUppercase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_isEqualAnyCase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_split(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_splitAt(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_fromBase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_toBase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_foreach(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asMessage(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_cloneAppendSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asMutable(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asUppercase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asLowercase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_lastPathComponent(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_pathExtension(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_fileName(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_cloneAppendPath(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_pathComponent(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asOSPath(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asIoPath(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_beforeSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_afterSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_occurancesOfSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asBase64(IoSeq* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoSeq_inline
 ****************************************************************************/
int ISMUTABLESEQ(IoObject* self);


/****************************************************************************
     IoSeq_mutable
 ****************************************************************************/
void IoSeq_addMutableMethods(IoSeq* self);
void IoSeq_rawPio_reallocateToSize_(IoSeq* self, size_t size);
int IoSeq_byteCompare(const(void)* a, const(void)* b);
IoObject* IoSeq_setItemType(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_convertToItemType(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_convertToFixedSizeType(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_setEncoding(IoSeq* self, IoObject* locals, IoMessage* m);
void IoSeq_rawCopy_(IoSeq* self, IoSeq* other);
IoObject* IoSeq_copy(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_appendSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_append(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_atInsertSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_insertSeqEvery(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removeAt(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removeSlice(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removeLast(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_leaveThenRemove(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_setSize(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_preallocateToSize(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_replaceSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removeSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_replaceFirstSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_atPut(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_lowercase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_uppercase(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_translate(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_clipBeforeSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_clipAfterSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_clipBeforeEndOfSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_clipAfterStartOfSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_empty(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_sort(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_reverseInPlace(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removeOddIndexes(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removeEvenIndexes(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_duplicateIndexes(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_replaceMap(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_strip(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_lstrip(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_rstrip(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_escape(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_unescape(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removePref_ix(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_removeSuffix(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_capitalize(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_appendPathSeq(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_asCapitalized(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_interpolateInPlace(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_addEquals(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_subtractEquals(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_multiplyEquals(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_divideEquals(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_add(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_subtract(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_multiply(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_divide(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_dotProduct(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_sum(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_product(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_min(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_max(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_arithmeticMeanAsDouble(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_arithmeticMeanSquareAsDouble(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_square(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_abs(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_ceil(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_floor(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_log(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_log10(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_negate(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_rangeFill(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_clear(IoSeq* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoSeq_vector
 ****************************************************************************/
int ISVECTOR(IoObject* self);
void* IoMessage_locals_vectorArgAt_(IoMessage* self, void* locals, int n);
void* IoMessage_locals_pointArgAt_(IoMessage* m, void* locals, int n);
void IoSeq_assertIsVector(IoObject* self, IoObject* locals, IoMessage* m);
IoSeq* IoSeq_newFloatArrayOfSize_(void* state, size_t size);
float* IoSeq_floatPointerOfLength_(IoSeq* self, size_t size);
IoSeq* IoSeq_newVec2f(void* state, vec2f v);
int IoSeq_isVec2f(IoSeq* self);
vec2f IoSeq_vec2f(IoSeq* self);
void IoSeq_setVec2f_(IoSeq* self, vec2f v);
IoSeq* IoSeq_newVec3f(void* state, vec3f v);
int IoSeq_isVec3f(IoSeq* self);
vec3f IoSeq_vec3f(IoSeq* self);
void IoSeq_setVec3f_(IoSeq* self, vec3f v);
IoObject* IoSeq_x(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_y(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_z(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_w(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_setX(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_setY(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_setZ(IoSeq* self, IoObject* locals, IoMessage* m);
IoObject* IoSeq_setW(IoSeq* self, IoObject* locals, IoMessage* m);


/****************************************************************************
     IoState
 ****************************************************************************/
IoState* IoState_new();
void IoState_new_atAddress(void* address);
void IoState_init(IoState* self);
void IoState_registerProtoWithFunc_(IoState* self, IoObject* proto, IoStateProtoFunc func);
IoObject* IoState_protoWithInitFunction_(IoState* self, IoStateProtoFunc func);
IoObject* IoState_protoWithName_(IoState* self, const(char)* name);
void IoState_done(IoState* self);
void IoState_free(IoState* self);
IoObject* IoState_lobby(IoState* self);
void IoState_setLobby_(IoState* self, IoObject* obj);
void IoState_argc_argv_(IoState* self, int argc, const(char)* argv[]);
void IoState_runCLI(IoState* self);
// IoObject* IoState_objectWithPid_(IoState* self, PID_TYPE pid);
int IoState_exitResult(IoState* self);


/****************************************************************************
     IoState_callbacks
 ****************************************************************************/
void IoState_callbackContext_(IoState* self, void* context);
void* IoState_callbackContext(IoState* self);
void IoState_setBindingsInitCallback(IoState* self, IoStateBindingsInitCallback callback);
void IoState_print_(IoState* self, const(char)* format, ...);
void IoState_justPrint_(IoState* self, const(ubyte)* s, const(size_t) size);
void IoState_justPrintln_(IoState* self);
void IoState_justPrintba_(IoState* self, UArray* ba);
void IoState_printCallback_(IoState* self, IoStatePrintCallback callback);
void IoState_exceptionCallback_(IoState* self, IoStateExceptionCallback callback);
void IoState_exception_(IoState* self, IoObject* e);
void IoState_exitCallback_(IoState* self, IoStateExitCallback callback);
void IoState_exit(IoState* self, int returnCode);
void IoState_activeCoroCallback_(IoState* self, IoStateActiveCoroCallback callback);
void IoState_schedulerUpdate(IoState* self, int count);


/****************************************************************************
     IoState_coros
 ****************************************************************************/
IoObject* IoState_currentCoroutine(IoState* self);
void IoState_setCurrentCoroutine_(IoState* self, IoObject* coroutine);
void IoState_yield(IoState* self);


/****************************************************************************
     IoState_eval
 ****************************************************************************/
IoObject* IoState_tryToPerform(IoState* self, IoObject* target, IoObject* locals, IoMessage* m);
IoObject* IoState_rawOn_doCString_withLabel_(IoState* self, IoObject* target, const(char)* s, const(char)* label);
IoObject* IoState_doCString_(IoState* self, const(char)* s);
IoObject* IoState_on_doCString_withLabel_(IoState* self, IoObject* target, const(char)* s, const(char)* label);
void IoState_zeroSandboxCounts(IoState* self);
void IoState_resetSandboxCounts(IoState* self);
IoObject* IoState_doSandboxCString_(IoState* self, const(char)* s);
double IoState_endTime(IoState* self);
IoObject* IoState_doFile_(IoState* self, const(char)* path);


/****************************************************************************
     IoState_exceptions
 ****************************************************************************/
void IoState_fatalError_(IoState* self, char* error);
void IoState_error_(IoState* self, IoMessage* m, const(char)* format, ...);


/****************************************************************************
     IoState_inline
 ****************************************************************************/
IoObject* IOTRUE(IoObject* self);
int ISTRUE(IoObject* self);
IoObject* IOFALSE(IoObject* self);
int ISFALSE(IoObject* self);
IoObject* IOBOOL(IoObject* self, int b);
IoObject* IoState_retain_(IoState* self, IoObject* v);
void IoState_stopRetaining_(IoState* self, IoObject* v);
void* IoState_unref_erencedStackRetain_(IoState* self, IoObject* v);
void* IoState_stackRetain_(IoState* self, IoObject* v);
void IoState_addValue_(IoState* self, IoObject* v);
void IoState_addValueIfNecessary_(IoState* self, IoObject* v);
void IoState_pushCollectorPause(IoState* self);
void IoState_popCollectorPause(IoState* self);
void IoState_clearRetainStack(IoState* self);
uintptr_t IoState_pushRetainPool(void* self);
void IoState_clearTopPool(void* self);
void IoState_popRetainPool(void* self);
void IoState_popRetainPool_(void* self, uintptr_t mark);
void IoState_popRetainPoolExceptFor_(void* state, void* obj);
IoObject* IoMessage_locals_quickValueArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_valueArgAt_(IoMessage* self, IoObject* locals, int n);
IoObject* IoMessage_locals_firstStringArg(IoMessage* self, IoObject* locals);
void IoState_break(IoState* self, IoObject* v);
void IoState_continue(IoState* self);
void IoState_eol(IoState* self);
void IoState_return(IoState* self, IoObject* v);
void IoState_resetStopStatus(IoState* self);
int IoState_handleStatus(IoState* self);
IoObject* IoState_stopStatusObject(IoState* self, int stopStatus);
int IoState_stopStatusNumber(IoState* self, IoObject* obj);


/****************************************************************************
     IoState_symbols
 ****************************************************************************/
void IoState_setupCachedNumbers(IoState* self);
IoObject* IoState_numberWithDouble_(IoState* self, double n);
IoSymbol* IoState_symbolWithUArray_copy_(IoState* self, UArray* ba, int copy);
IoSymbol* IoState_symbolWithCString_(IoState* self, const(char)* s);
IoSymbol* IoState_symbolWithCString_length_(IoState* self, const(char)* s, size_t length);
IoSymbol* IoState_addSymbol_(IoState* self, IoSymbol* s);
void IoState_removeSymbol_(IoState* self, IoSymbol* aString);


/****************************************************************************
     IoTag
 ****************************************************************************/
IoTag* IoTag_new();
IoTag* IoTag_newWithName_(const(char)* name);
void IoTag_free(IoTag* self);
int IoTag_ref_erence(IoTag* self);
void IoTag_name_(IoTag* self, const(char)* name);
const(char)* IoTag_name(IoTag* self);
void IoTag_mark(IoTag* self);


/****************************************************************************
     IoTag_inline
 ****************************************************************************/
void IoTag_state_(IoTag* self, void* state);
void* IoTag_state(IoTag* self);
void IoTag_activateFunc_(IoTag* self, IoTagActivateFunc func);
IoTagActivateFunc IoTag_activateFunc(IoTag* self);
void IoTag_cloneFunc_(IoTag* self, IoTagCloneFunc func);
IoTagCloneFunc IoTag_cloneFunc(IoTag* self);
void IoTag_cleanupFunc_(IoTag* self, IoTagFreeFunc func);
IoTagCleanupFunc IoTag_cleanupFunc(IoTag* self);
void IoTag_freeFunc_(IoTag* self, IoTagFreeFunc func);
IoTagFreeFunc IoTag_freeFunc(IoTag* self);
void IoTag_markFunc_(IoTag* self, IoTagMarkFunc func);
IoTagMarkFunc IoTag_markFunc(IoTag* self);
void IoTag_compareFunc_(IoTag* self, IoTagCompareFunc func);
IoTagCompareFunc IoTag_compareFunc(IoTag* self);
void IoTag_writeToStreamFunc_(IoTag* self, IoTagWriteToStreamFunc func);
IoTagWriteToStreamFunc IoTag_writeToStreamFunc(IoTag* self);
void IoTag_allocFromStreamFunc_(IoTag* self, IoTagAllocFromStreamFunc func);
IoTagAllocFromStreamFunc IoTag_allocFromStreamFunc(IoTag* self);
void IoTag_readFromStreamFunc_(IoTag* self, IoTagReadFromStreamFunc func);
IoTagReadFromStreamFunc IoTag_readFromStreamFunc(IoTag* self);
void IoTag_notificationFunc_(IoTag* self, IoTagNotificationFunc func);
IoTagNotificationFunc IoTag_notificationFunc(IoTag* self);
void IoTag_performFunc_(IoTag* self, IoTagPerformFunc func);
IoTagPerformFunc IoTag_performFunc(IoTag* self);


/****************************************************************************
     IoVMApi
 ****************************************************************************/


/****************************************************************************
     PHash
 ****************************************************************************/
size_t PHash_size(PHash* self); // actually the keyCount;
void PHash_setSize_(PHash* self, size_t size);
void PHash_insert_(PHash* self, PHashRecord* x);
void PHash_grow(PHash* self);
void PHash_shrink(PHash* self);
void PHash_show(PHash* self);
void PHash_updateMask(PHash* self);


/****************************************************************************
     PHash_inline
 ****************************************************************************/
uint PHash_hash(PHash* self, void* key);
uint PHash_hash_more(PHash* self, uint hash);
PHashRecord* PHash_record1_(PHash* self, void* k);
PHashRecord* PHash_record2_(PHash* self, void* k);
void* PHash_at_(PHash* self, void* k);
uint PHash_count(PHash* self);
int PHashKey_hasKey_(PHash* self, void* key);
void PHash_at_put_(PHash* self, void* k, void* v);
void PHash_shrinkIfNeeded(PHash* self);
void PHashRecord_swapWith_(PHashRecord* self, PHashRecord* other);
void PHash_clean(PHash* self);
