
import iovmapi;
import iowrap;
import std.traits, std.stdio;
import std.string;
import std.conv;
import std.file;
import std.c.stdlib;


extern(C) void MyPrint(IoState* self, const(UArray)* s) {
    printf("%s", UArray_asCString(s));
}
extern(C) void MyExit(IoState* self) {
    exit(0);
}


void mywrite(string s) {
    writeln("mywrite: ", s);
}

struct Hoge {
    int i;
    string s;
    private int n;
}
void hogefun(Hoge h) {
    writeln("i:", h.i, " s:", h.s);
}
class Fuga {
    alias int H;
    private int i;
    this() {
    }
    this(int i) {
        this.i = i;
    }
    void show() {
        writeln("Fuga.i: ", i);
    }
}


void main() {
    // initialize
    auto self = IoState_new();
    scope(exit) IoState_free(self);
    IoState_init(self);
    IoState_printCallback_(self, &MyPrint);
    IoState_exitCallback_(self, &MyExit);

    // register functions
    auto lobby = IoState_lobby(self);
    IoObject_addMethod_(lobby, IOSYMBOL(self, "read"), &IoFunctionWrap!(std.file.read));
    IoObject_addMethod_(lobby, IOSYMBOL(self, "mywrite"), &IoFunctionWrap!(mywrite));
    IoObject_addMethod_(lobby, IOSYMBOL(self, "hogefun"), &IoFunctionWrap!(hogefun));

    // use D struct
    Hoge h;
    h.i = 100;
    h.s = "start";
    IoObject_setSlot_to_(lobby, IOSYMBOL(self, "h"), IoObjectFrom(self, h));

    // use D class
    auto f = new Fuga;
    IoObject_setSlot_to_(lobby, IOSYMBOL(self, "f"), IoObjectFrom(self, f));
    
    // dofile
    IoState_doFile_(self, "test.io");

    // io call
    IoObject* piobj = IoState_doCString_(self, "1 atan * 4");
    double pi = IoObjectTo!double(piobj);
    writeln("pi: ", pi);
}

